diff --git a/src/util/crypto/nss/nss_obfuscate.c b/src/util/crypto/nss/nss_obfuscate.c
index 8c6bdc52524ad7f7a491603e9fd2902fdf9eed18..a55f22b6de0cfdf23f4728ccfb8d4e68d155544b 100644
--- a/src/util/crypto/nss/nss_obfuscate.c
+++ b/src/util/crypto/nss/nss_obfuscate.c
@@ -31,42 +31,17 @@
  */
 
 #include "config.h"
-
 #include <prerror.h>
-#include <nss.h>
 #include <pk11func.h>
-#include <base64.h>
-#include <talloc.h>
 
 #include "util/util.h"
 #include "util/crypto/sss_crypto.h"
 #include "util/crypto/nss/nss_util.h"
+#include "util/crypto/nss/nss_crypto.h"
 
 #define OBF_BUFFER_SENTINEL "\0\1\2\3"
 #define OBF_BUFFER_SENTINEL_SIZE    4
 
-#define MAKE_SECITEM(sdata, slen, sitem) do { \
-    (sitem)->type = (siBuffer); \
-    (sitem)->data = (sdata);    \
-    (sitem)->len  = (slen);     \
-} while(0)
-
-struct sss_nss_crypto_ctx {
-    PK11SlotInfo *slot;
-    PK11Context  *ectx;
-    PK11SymKey   *keyobj;
-    SECItem      *sparam;
-
-    SECItem      *iv;
-    SECItem      *key;
-};
-
-struct crypto_mech_data {
-    CK_MECHANISM_TYPE cipher;
-    uint16_t keylen;
-    uint16_t bsize;
-};
-
 static struct crypto_mech_data cmdata[] = {
     /* AES with automatic padding, 256b key, 128b block */
     { CKM_AES_CBC_PAD, 32, 16 },
@@ -83,147 +58,6 @@ static struct crypto_mech_data *get_crypto_mech_data(enum obfmethod meth)
     return &cmdata[meth];
 }
 
-static int generate_random_key(TALLOC_CTX *mem_ctx,
-                               PK11SlotInfo *slot,
-                               struct crypto_mech_data *mech_props,
-                               SECItem **_key)
-{
-    SECStatus sret;
-    SECItem      *randkeydata;
-    SECItem      *key = NULL;
-    PK11SymKey   *randkey;
-    int ret;
-
-    randkey = PK11_KeyGen(slot, mech_props->cipher,
-                          NULL, mech_props->keylen, NULL);
-    if (randkey == NULL) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to generate key (err %d)\n",
-                  PR_GetError());
-        ret = EIO;
-        goto done;
-    }
-
-    sret = PK11_ExtractKeyValue(randkey);
-    if (sret != SECSuccess) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to extract key value (err %d)\n",
-                  PR_GetError());
-        ret = EIO;
-        goto done;
-    }
-
-    randkeydata = PK11_GetKeyData(randkey);
-    if (randkeydata == NULL) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to get key data (err %d)\n",
-                  PR_GetError());
-        ret = EIO;
-        goto done;
-    }
-
-    /* randkeydata is valid until randkey is. Copy with talloc to
-     * get a nice memory hierarchy symmetrical in encrypt
-     * and decrypt case */
-    key = talloc_zero(mem_ctx, SECItem);
-    if (!key) {
-        ret = ENOMEM;
-        goto done;
-    }
-
-    key->data = talloc_memdup(key, randkeydata->data, randkeydata->len);
-    if (!key->data) {
-        ret = ENOMEM;
-        goto done;
-    }
-    key->len = randkeydata->len;
-
-    *_key = key;
-    ret = EOK;
-done:
-    if (ret != EOK) talloc_zfree(key);
-    PK11_FreeSymKey(randkey);
-    return ret;
-}
-
-static int sss_nss_crypto_ctx_destructor(struct sss_nss_crypto_ctx *cctx)
-{
-    if (cctx->ectx) PK11_DestroyContext(cctx->ectx, PR_TRUE);
-    if (cctx->sparam) SECITEM_FreeItem(cctx->sparam, PR_TRUE);
-    if (cctx->slot) PK11_FreeSlot(cctx->slot);
-    if (cctx->keyobj) PK11_FreeSymKey(cctx->keyobj);
-
-    return EOK;
-}
-
-static int nss_ctx_init(TALLOC_CTX *mem_ctx,
-                        struct crypto_mech_data *mech_props,
-                        struct sss_nss_crypto_ctx **_cctx)
-{
-    struct sss_nss_crypto_ctx *cctx;
-    int ret;
-
-    cctx = talloc_zero(mem_ctx, struct sss_nss_crypto_ctx);
-    if (!cctx) {
-        return ENOMEM;
-    }
-    talloc_set_destructor(cctx, sss_nss_crypto_ctx_destructor);
-
-    cctx->slot = PK11_GetBestSlot(mech_props->cipher, NULL);
-    if (cctx->slot == NULL) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Unable to find security device (err %d)\n",
-                  PR_GetError());
-        ret = EIO;
-        goto done;
-    }
-
-    ret = EOK;
-    *_cctx = cctx;
-done:
-    if (ret) talloc_zfree(cctx);
-    return ret;
-}
-
-static int nss_encrypt_decrypt_init(struct crypto_mech_data *mech_props,
-                                    bool do_encrypt,
-                                    struct sss_nss_crypto_ctx *cctx)
-{
-    CK_ATTRIBUTE_TYPE   op;
-    int ret;
-
-    op = do_encrypt ? CKA_ENCRYPT : CKA_DECRYPT;
-
-    /* turn the raw key into a key object */
-    cctx->keyobj = PK11_ImportSymKey(cctx->slot, mech_props->cipher,
-                                     PK11_OriginUnwrap, op, cctx->key, NULL);
-    if (cctx->keyobj == NULL) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to import key into NSS (err %d)\n",
-                  PR_GetError());
-        ret = EIO;
-        goto done;
-    }
-
-    /* turn the raw IV into a initialization vector object */
-    cctx->sparam = PK11_ParamFromIV(mech_props->cipher, cctx->iv);
-    if (cctx->sparam == NULL) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to set up PKCS11 param (err %d)\n",
-                  PR_GetError());
-        ret = EIO;
-        goto done;
-    }
-
-    /* Create cipher context */
-    cctx->ectx = PK11_CreateContextBySymKey(mech_props->cipher, op,
-                                            cctx->keyobj, cctx->sparam);
-    if (cctx->ectx == NULL) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Cannot create cipher context (err %d)\n",
-                  PORT_GetError());
-        ret = EIO;
-        goto done;
-    }
-
-    ret = EOK;
-done:
-    return ret;
-}
-
 int sss_password_encrypt(TALLOC_CTX *mem_ctx, const char *password, int plen,
                          enum obfmethod meth, char **obfpwd)
 {
@@ -263,27 +97,14 @@ int sss_password_encrypt(TALLOC_CTX *mem_ctx, const char *password, int plen,
         goto done;
     }
 
-    ret = nss_ctx_init(tmp_ctx, mech_props, &cctx);
+    /* Initiualize ctx and generate random encryption and IV key */
+    ret = nss_ctx_init(tmp_ctx, mech_props, NULL, 1, NULL, 1, &cctx);
     if (ret) {
         DEBUG(SSSDBG_CRIT_FAILURE, "Cannot initialize NSS context\n");
         goto done;
     }
 
-    /* generate random encryption and IV key */
-    ret = generate_random_key(cctx, cctx->slot, mech_props, &cctx->key);
-    if (ret != EOK) {
-        DEBUG(SSSDBG_CRIT_FAILURE, "Could not generate encryption key\n");
-        goto done;
-    }
-
-    ret = generate_random_key(cctx, cctx->slot, mech_props, &cctx->iv);
-    if (ret != EOK) {
-        DEBUG(SSSDBG_CRIT_FAILURE,
-              "Could not generate initialization vector\n");
-        goto done;
-    }
-
-    ret = nss_encrypt_decrypt_init(mech_props, true, cctx);
+    ret = nss_crypto_init(mech_props, op_encrypt, cctx);
     if (ret) {
         DEBUG(SSSDBG_CRIT_FAILURE,
               "Cannot initialize NSS context properties\n");
@@ -431,7 +252,8 @@ int sss_password_decrypt(TALLOC_CTX *mem_ctx, char *b64encoded,
     memcpy(sentinel_check,
            obfbuf + p + mech_props->keylen + mech_props->bsize + ctsize,
            OBF_BUFFER_SENTINEL_SIZE);
-    if (memcmp(sentinel_check, OBF_BUFFER_SENTINEL, OBF_BUFFER_SENTINEL_SIZE) != 0) {
+    if (memcmp(sentinel_check,
+               OBF_BUFFER_SENTINEL, OBF_BUFFER_SENTINEL_SIZE) != 0) {
         DEBUG(SSSDBG_FATAL_FAILURE,
               "Obfuscation buffer seems corrupt, aborting\n");
         ret = EFAULT;
@@ -460,23 +282,15 @@ int sss_password_decrypt(TALLOC_CTX *mem_ctx, char *b64encoded,
     }
     safealign_memcpy(cryptotext, obfbuf+p, ctsize, &p);
 
-    ret = nss_ctx_init(tmp_ctx, mech_props, &cctx);
+    ret = nss_ctx_init(tmp_ctx, mech_props,
+                       keybuf, mech_props->keylen,
+                       ivbuf, mech_props->bsize, &cctx);
     if (ret) {
         DEBUG(SSSDBG_CRIT_FAILURE, "Cannot initialize NSS context\n");
         goto done;
     }
 
-    cctx->iv = talloc_zero(cctx, SECItem);
-    cctx->key = talloc_zero(cctx, SECItem);
-    if (!cctx->iv || !cctx->key) {
-        ret = ENOMEM;
-        goto done;
-    }
-
-    MAKE_SECITEM(ivbuf, mech_props->bsize, cctx->iv);
-    MAKE_SECITEM(keybuf, mech_props->keylen, cctx->key);
-
-    ret = nss_encrypt_decrypt_init(mech_props, false, cctx);
+    ret = nss_crypto_init(mech_props, op_decrypt, cctx);
     if (ret) {
         goto done;
     }
@@ -487,8 +301,8 @@ int sss_password_decrypt(TALLOC_CTX *mem_ctx, char *b64encoded,
         goto done;
     }
 
-    sret = PK11_CipherOp(cctx->ectx, (unsigned char *) pwdbuf, &plainlen, ctsize,
-                         cryptotext, ctsize);
+    sret = PK11_CipherOp(cctx->ectx, (unsigned char *) pwdbuf, &plainlen,
+                         ctsize, cryptotext, ctsize);
     if (sret != SECSuccess) {
         DEBUG(SSSDBG_CRIT_FAILURE,
               "Cannot execute the encryption operation (err %d)\n",
@@ -497,8 +311,8 @@ int sss_password_decrypt(TALLOC_CTX *mem_ctx, char *b64encoded,
         goto done;
     }
 
-    sret = PK11_DigestFinal(cctx->ectx, (unsigned char *) pwdbuf+plainlen, &digestlen,
-                            ctsize - plainlen);
+    sret = PK11_DigestFinal(cctx->ectx, (unsigned char *) pwdbuf+plainlen,
+                            &digestlen, ctsize - plainlen);
     if (sret != SECSuccess) {
         DEBUG(SSSDBG_CRIT_FAILURE,
               "Cannot execute the encryption operation (err %d)\n",
diff --git a/src/util/crypto/nss/nss_util.c b/src/util/crypto/nss/nss_util.c
index 55b81c9b1c8e92e7a16348767a589eb8c92e9330..46835057b04e587b77aed4479c0243522819fd94 100644
--- a/src/util/crypto/nss/nss_util.c
+++ b/src/util/crypto/nss/nss_util.c
@@ -26,12 +26,11 @@
 #include "config.h"
 
 #include <prinit.h>
-#include <prerror.h>
 #include <nss.h>
-#include <pk11func.h>
 
 #include "util/util.h"
 #include "util/crypto/nss/nss_util.h"
+#include "util/crypto/nss/nss_crypto.h"
 
 static int nspr_nss_init_done = 0;
 
@@ -75,3 +74,211 @@ int nspr_nss_cleanup(void)
     nspr_nss_init_done = 0;
     return EOK;
 }
+
+static int sss_nss_crypto_ctx_destructor(struct sss_nss_crypto_ctx *cctx)
+{
+    if (cctx->ectx) PK11_DestroyContext(cctx->ectx, PR_TRUE);
+    if (cctx->sparam) SECITEM_FreeItem(cctx->sparam, PR_TRUE);
+    if (cctx->slot) PK11_FreeSlot(cctx->slot);
+    if (cctx->keyobj) PK11_FreeSymKey(cctx->keyobj);
+
+    return EOK;
+}
+
+static int generate_random_key(TALLOC_CTX *mem_ctx,
+                               PK11SlotInfo *slot,
+                               struct crypto_mech_data *mech_props,
+                               SECItem **_key)
+{
+    SECStatus sret;
+    SECItem      *randkeydata;
+    SECItem      *key = NULL;
+    PK11SymKey   *randkey;
+    int ret;
+
+    randkey = PK11_KeyGen(slot, mech_props->cipher,
+                          NULL, mech_props->keylen, NULL);
+    if (randkey == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to generate key (err %d)\n",
+                  PR_GetError());
+        ret = EIO;
+        goto done;
+    }
+
+    sret = PK11_ExtractKeyValue(randkey);
+    if (sret != SECSuccess) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to extract key value (err %d)\n",
+                  PR_GetError());
+        ret = EIO;
+        goto done;
+    }
+
+    randkeydata = PK11_GetKeyData(randkey);
+    if (randkeydata == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to get key data (err %d)\n",
+                  PR_GetError());
+        ret = EIO;
+        goto done;
+    }
+
+    /* randkeydata is valid until randkey is. Copy with talloc to
+     * get a nice memory hierarchy symmetrical in encrypt
+     * and decrypt case */
+    key = talloc_zero(mem_ctx, SECItem);
+    if (!key) {
+        ret = ENOMEM;
+        goto done;
+    }
+
+    key->data = talloc_memdup(key, randkeydata->data, randkeydata->len);
+    if (!key->data) {
+        ret = ENOMEM;
+        goto done;
+    }
+    key->len = randkeydata->len;
+
+    *_key = key;
+    ret = EOK;
+done:
+    if (ret != EOK) talloc_zfree(key);
+    PK11_FreeSymKey(randkey);
+    return ret;
+}
+
+int nss_ctx_init(TALLOC_CTX *mem_ctx,
+                 struct crypto_mech_data *mech_props,
+                 uint8_t *key, int keylen,
+                 uint8_t *iv, int ivlen,
+                 struct sss_nss_crypto_ctx **_cctx)
+{
+    struct sss_nss_crypto_ctx *cctx;
+    int ret;
+
+    cctx = talloc_zero(mem_ctx, struct sss_nss_crypto_ctx);
+    if (!cctx) {
+        return ENOMEM;
+    }
+    talloc_set_destructor(cctx, sss_nss_crypto_ctx_destructor);
+
+    cctx->slot = PK11_GetBestSlot(mech_props->cipher, NULL);
+    if (cctx->slot == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Unable to find security device (err %d)\n",
+                  PR_GetError());
+        ret = EIO;
+        goto done;
+    }
+
+    if (keylen > 0) {
+        cctx->key = talloc(cctx, SECItem);
+        if (cctx->key == NULL) {
+            DEBUG(SSSDBG_CRIT_FAILURE,
+                  "Failed to allocate Key buffer\n");
+            ret = ENOMEM;
+            goto done;
+        }
+        if (key) {
+            MAKE_SECITEM(key, keylen, cctx->key);
+        } else {
+            ret = generate_random_key(cctx, cctx->slot,
+                                      mech_props, &cctx->key);
+            if (ret != EOK) {
+                DEBUG(SSSDBG_CRIT_FAILURE,
+                      "Could not generate encryption key\n");
+                goto done;
+            }
+        }
+
+    }
+
+    if (ivlen > 0) {
+        cctx->iv = talloc(cctx, SECItem);
+        if (cctx->iv == NULL) {
+            DEBUG(SSSDBG_CRIT_FAILURE, "Failed to allocate IV buffer\n");
+            ret = ENOMEM;
+            goto done;
+        }
+        if (iv) {
+            MAKE_SECITEM(iv, ivlen, cctx->iv);
+        } else {
+            ret = generate_random_key(cctx, cctx->slot,
+                                      mech_props, &cctx->iv);
+            if (ret != EOK) {
+                DEBUG(SSSDBG_CRIT_FAILURE,
+                      "Could not generate initialization vector\n");
+                goto done;
+            }
+        }
+    }
+
+    ret = EOK;
+    *_cctx = cctx;
+done:
+    if (ret) talloc_zfree(cctx);
+    return ret;
+}
+
+int nss_crypto_init(struct crypto_mech_data *mech_props,
+                    enum crypto_mech_op crypto_op,
+                    struct sss_nss_crypto_ctx *cctx)
+{
+    CK_ATTRIBUTE_TYPE op;
+    int ret;
+
+    switch (crypto_op) {
+    case op_encrypt:
+        op = CKA_ENCRYPT;
+        break;
+    case op_decrypt:
+        op = CKA_DECRYPT;
+        break;
+    case op_sign:
+        op = CKA_SIGN;
+        break;
+    default:
+        return EFAULT;
+    }
+
+    /* turn the raw key into a key object */
+    cctx->keyobj = PK11_ImportSymKey(cctx->slot, mech_props->cipher,
+                                     PK11_OriginUnwrap, op, cctx->key, NULL);
+    if (cctx->keyobj == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Failure to import key into NSS (err %d)\n",
+                  PR_GetError());
+        ret = EIO;
+        goto done;
+    }
+
+    if (crypto_op == op_encrypt || crypto_op == op_decrypt) {
+        /* turn the raw IV into a initialization vector object */
+        cctx->sparam = PK11_ParamFromIV(mech_props->cipher, cctx->iv);
+        if (cctx->sparam == NULL) {
+            DEBUG(SSSDBG_CRIT_FAILURE,
+                  "Failure to set up PKCS11 param (err %d)\n",
+                  PR_GetError());
+            ret = EIO;
+            goto done;
+        }
+    } else {
+        cctx->sparam = SECITEM_AllocItem(NULL, NULL, 0);
+        if (cctx->sparam == NULL) {
+            DEBUG(SSSDBG_CRIT_FAILURE, "Failure to allocate SECItem\n");
+            ret = EIO;
+            goto done;
+        }
+        MAKE_SECITEM(NULL, 0, cctx->sparam);
+    }
+
+    /* Create cipher context */
+    cctx->ectx = PK11_CreateContextBySymKey(mech_props->cipher, op,
+                                            cctx->keyobj, cctx->sparam);
+    if (cctx->ectx == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Cannot create cipher context (err %d)\n",
+                  PORT_GetError());
+        ret = EIO;
+        goto done;
+    }
+
+    ret = EOK;
+done:
+    return ret;
+}
diff --git a/src/util/crypto/nss/nss_util.h b/src/util/crypto/nss/nss_util.h
index 7387b9a7e0d602c81b2123a9c4bd263ed6501ab8..08ab58d87e64631a5b4cfa840bc78f038fda3977 100644
--- a/src/util/crypto/nss/nss_util.h
+++ b/src/util/crypto/nss/nss_util.h
@@ -22,6 +22,7 @@
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
+#include <nss.h>
 
 int nspr_nss_init(void);
 int nspr_nss_cleanup(void);
diff --git a/src/util/crypto/sss_crypto.c b/src/util/crypto/sss_crypto.c
new file mode 100644
index 0000000000000000000000000000000000000000..4c775f3d926ae32f3cb72b1329c0a025a0550ed5
--- /dev/null
+++ b/src/util/crypto/sss_crypto.c
@@ -0,0 +1,66 @@
+/*
+    Authors:
+        Simo Sorce <ssorce@redhat.com>
+
+    Copyright (C) 2016 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "config.h"
+#include "util/util.h"
+#include "util/crypto/sss_crypto.h"
+
+int generate_csprng_buffer(uint8_t *buf, size_t size)
+{
+    ssize_t rsize;
+    ssize_t pos;
+    int ret;
+    int fd;
+
+    fd = open("/dev/urandom", O_RDONLY);
+    if (fd == -1) return errno;
+
+    rsize = 0;
+    pos = 0;
+    while (rsize < size) {
+        rsize = read(fd, buf + pos, size - pos);
+        switch (rsize) {
+        case -1:
+            if (errno == EINTR) continue;
+            ret = EIO;
+            goto done;
+        case 0:
+            ret = EIO;
+            goto done;
+        default:
+            if (rsize + pos < size - pos) {
+                pos += rsize;
+                continue;
+            }
+            ret = EIO;
+            goto done;
+        }
+    }
+    if (rsize != size) {
+        ret = EFAULT;
+        goto done;
+    }
+
+    ret = EOK;
+
+done:
+    close(fd);
+    return ret;
+}
diff --git a/src/util/crypto/sss_crypto.h b/src/util/crypto/sss_crypto.h
index 5b40ecfc483e3696b2c549bf5ea25a969f12bb8c..8c7a883177d6a4be3309ce3374401626eb3fd04f 100644
--- a/src/util/crypto/sss_crypto.h
+++ b/src/util/crypto/sss_crypto.h
@@ -1,3 +1,24 @@
+/*
+    Copyright (C) 2009-2016 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef _SSS_CRYPTO_H_
+#define _SSS_CRYPTO_H_
+
+int generate_csprng_buffer(uint8_t *buf, size_t size);
 
 int s3crypt_sha512(TALLOC_CTX *mmectx,
                    const char *key, const char *salt, char **_hash);
@@ -32,3 +53,19 @@ int sss_password_encrypt(TALLOC_CTX *mem_ctx, const char *password, int plen,
 
 int sss_password_decrypt(TALLOC_CTX *mem_ctx, char *b64encoded,
                          char **password);
+
+enum encmethod {
+    AES256CBC_HMAC_SHA256,
+    NUM_ENCMETHODS
+};
+
+int sss_encrypt(TALLOC_CTX *mem_ctx, enum encmethod enctype,
+                uint8_t *key, size_t keylen,
+                const uint8_t *plaintext, size_t plainlen,
+                uint8_t **ciphertext, size_t *cipherlen);
+int sss_decrypt(TALLOC_CTX *mem_ctx, enum encmethod enctype,
+                uint8_t *key, size_t keylen,
+                const uint8_t *ciphertext, size_t cipherlen,
+                uint8_t **plaintext, size_t *plainlen);
+
+#endif /* _SSS_CRYPTO_H_ */
-- 
2.5.5

